DECLARE SUB VisBSVFil (FilNavn$)
DECLARE SUB VisFil (FilNavn AS STRING)
DECLARE SUB Center (Tekst$, Linie!)
DECLARE SUB HentFont ()
DECLARE SUB Xpress (text AS STRING, x%, Y%, FontColor%, Size%, Skygge%)
DECLARE SUB VaelgStyring ()
DECLARE SUB SkydStoreMissiler ()
DECLARE SUB SkydSmaaMissiler ()
DECLARE SUB JoyStickStyring ()
DECLARE SUB JoystickKalibrering (Maade AS STRING)
DECLARE SUB CheckHiscore (Handling$)
DECLARE SUB StartDrop ()
DECLARE SUB Intro ()
DECLARE SUB NyBane ()
DECLARE SUB CheckTid ()
DECLARE SUB Flytdropopgradering ()
DECLARE SUB NyLevel ()
DECLARE SUB SlutSpillet (grund)
DECLARE SUB StartEksplosion (SkudX%, SkudY%, Vaaben%)
DECLARE SUB TegnEksplosioner ()
DECLARE SUB FlytFjender ()
DECLARE SUB KollisionsCheck (Vaaben%, nummer, SkudX%, SkudY%)
DECLARE SUB FlytSkud ()
DECLARE SUB LavStjerneMatrice ()
DECLARE SUB LavGetPut ()
DECLARE SUB LavGetPutTilDataBjaelken ()
DECLARE SUB TegnStjernerTilSkaerm ()
DECLARE SUB LavStjerneMatricer ()
DECLARE SUB InitVar ()
DECLARE SUB SkydLaser ()
DECLARE SUB FlytMissiler ()
DECLARE SUB TegnSprite (Sprite!)
DECLARE SUB FlytRumskib ()
DECLARE SUB Opdaterskaerm ()
DECLARE SUB CheckTast (Tast$)

TYPE SpillerVaesen
  Usaarlig AS INTEGER                   'Usaarlighed
  x AS INTEGER                          'Xplacering
  Y AS INTEGER                          'Yplacering
  GamleX AS INTEGER                     'Hvor var rumskibet sidst
  GamleY AS INTEGER                     'Hvor var rumskibet sidst
  Xstoerrelse AS INTEGER                'Pixels p en side
  Ystoerrelse AS INTEGER                'Pixels p en side
  GlimtFarve AS INTEGER                 'Til at lave glimt med, bestemmer farve
  GlimtTaeller AS INTEGER               'Til at lave glimt med, bestemmer tid
  RetningOpNed AS INTEGER
  RetningHV AS INTEGER
  Eksisterer AS STRING * 1
  Laser AS INTEGER                      'Hvor opgraderet er laseren
  SuperLaser AS STRING * 1              'Har spilleren fet superlaseren
  LaserEnergi AS INTEGER                'Hvor meget laserenergi er der tilbage
  EnergiPerLaserSkud AS INTEGER         'Hvad 'koster' det at skyde et skud
  StoreMissiler AS INTEGER              'Hvor mange af de store er der p rumskibet
  SmaaMissiler AS INTEGER               'Hvor mange af de sm er der p rumskibet
  LaserXOffset0 AS INTEGER              'Hvor mange pixels til venstre laser
  LaserXOffset1 AS INTEGER              'Hvor mange pixels til hjre laser
  SidsteLaserAfskudt AS INTEGER         'Hvilken laser blev sidst afskudt
  Points AS SINGLE                      'Hvor mange points har spilleren
  Livspoint AS INTEGER                  'Hvor mange skadepoint fr rumskibet er ddt
  Skjold AS INTEGER                     'Hvor meget skjold er der tilbage
  SkudSkudt AS INTEGER                  'Hvor mange skud har rumskibet skudt
  SkudRamtMed AS INTEGER                'Hvor mange skud har rumskibet ramt med
  TraefProcent AS INTEGER               'Hvor stor en procentdel af skuddene rammer
  AntalRumvaesenerFanget AS INTEGER     'Hvor mange rumvaesener har spilleren fanget
END TYPE

TYPE FjendeVaesen
  x AS INTEGER                  'Xplacering
  Y AS INTEGER                  'Yplacering
  GlimtTaeller AS INTEGER       'Til at lave glimt med, bestemmer tid
  RetningOpNed AS INTEGER
  RetningHV AS INTEGER
  Eksisterer AS STRING * 1
  Skyder AS STRING * 1          'Skyder de overhovedet?
  SidsteSkudTidspunkt AS DOUBLE 'Hvornaar skoed ufoen sidste gang
  Livspoint AS INTEGER          'Hvor mange skadepoint fr ufoen er dd
  UfoType AS INTEGER            'Hvilken slags ufoer er det
  NedreFlyveGraense AS INTEGER  'Hvor langt ned p skrmen flyver ufoerne
END TYPE

TYPE FjendeType
  Xstoerrelse AS INTEGER               'Pixels p en side
  Ystoerrelse AS INTEGER               'Pixels p en side
  skudtype AS INTEGER   'Hvad skyder de med?
  SkyderHvorTit AS SINGLE      'Hvor tit skyder de?
  NedreFlyveGraense AS INTEGER  'Hvor langt ned p skrmen flyver ufoerne
  Livspoint AS INTEGER   'Hvor mange skadepoint fr ufoen er dd
  Points AS INTEGER 'Hvor mange points giver vsenet at skyde?
END TYPE

TYPE Bang
  x AS INTEGER
  Y AS INTEGER
  Varighed AS INTEGER   'Hvor lang tid varer eksplosionen
  Alder AS INTEGER      'Hvor lang tid har den varet
  AntalGnister AS INTEGER
  Eksisterer AS STRING * 1
  farve AS INTEGER     'Hvilke farver bruges der
END TYPE

TYPE SkudTyper
  Xstoerrelse AS INTEGER               'Pixels p en side
  Ystoerrelse AS INTEGER               'Pixels p en side
  Sprite AS INTEGER     'Hvilken sprite skal bruges?
  RetningOpNed AS INTEGER
  MaxRetningHV AS INTEGER       'Hvor meget kan skudtypen dreje efter rumskibet
  Skade AS INTEGER      'Hvor meget skade gr skuddet
END TYPE

TYPE Skud
  x AS INTEGER  'Xplacering
  Y AS INTEGER  'Yplacering
  Eksisterer AS STRING * 1
  skudtype AS INTEGER
END TYPE

TYPE Gradtal
  x AS SINGLE
  Y AS SINGLE
END TYPE

TYPE level
  AntalUfoerIalt AS INTEGER
  UfoType AS INTEGER   'Hvilken fjendetype er der p denne bane
  NytLiv AS STRING * 1  'Skal der lades op med livspoints
  AntalSmaaMissiler AS INTEGER
  AntalStoreMissiler AS INTEGER
  AntalDropsPaaDenneBane AS INTEGER     'Hvor mange drops kommer der p denne bane
END TYPE

TYPE Drops
  Eksisterer AS STRING * 1
  Xstoerrelse AS INTEGER               'Pixels p en side
  Ystoerrelse AS INTEGER               'Pixels p en side
  RetningOpNed AS INTEGER
  RetningHV AS INTEGER
  DropType AS INTEGER   'Hvad gr droppet (laser opgrade etc.)
  x AS INTEGER
  Y AS INTEGER
END TYPE

TYPE TidsType
  BaneSlut AS STRING * 1        'Er banen overstet
  BanenSluttede AS DOUBLE       'Hvornr sluttede banen
  SpilletSlut AS STRING * 1     'Er rumskibet smadret
  SpilletSluttede AS DOUBLE     'Hvornr sluttede spillet?
  SpilletVundet AS STRING * 1   'Var det sidste bane
  BaneStart AS DOUBLE           'Hvornr startede spillet p denne bane
  LoekkeStart AS DOUBLE
  LoekkeInterval AS DOUBLE
  NaesteDrop AS DOUBLE
  StarterNytSpil AS STRING * 1  'Bruges til at bryde spillets lkker med
  Bonus AS INTEGER              'Hvor meget fr spilleren i tidsbonus
  TraefBonus AS INTEGER         'Hvor meget fr spilleren i skudbonus
  AntalBanerIAlt AS INTEGER     'Hvor mange baner er der lavet
  PauseStart AS DOUBLE          'Til at huske hvornr pausen startede
  HarSnydt AS STRING * 1        'Til at checke om spilleren har brugt snydekoder
  AntalDropsPaaDenneBane AS INTEGER      'Hvor mange drops har der vret endnu
END TYPE

TYPE StjerneType
  x AS INTEGER
  Y AS INTEGER
  lag AS INTEGER 'er det en baggrunds, mellem- eller forgrundsstjerne
END TYPE

TYPE StjerneFartOgFarve
  Fart AS INTEGER
  farve AS INTEGER
END TYPE

TYPE HighScoreType      'Til at holde highscore listen med
  Navn AS STRING * 13     'Navnet p spilleren
  Score AS LONG        'Hans/hendes score
END TYPE

TYPE Joy
  CurrX AS INTEGER      'Hvad er X og Y lige nu
  CurrY AS INTEGER
  MinX AS INTEGER       'Hvor langt kan joysticket g p X-aksen
  MaxX AS INTEGER
  MinY AS INTEGER       'Hvor langt kan joysticket g p Y-aksen
  MaxY AS INTEGER
  CenterX AS INTEGER
  CenterY AS INTEGER
  UnitPerX AS INTEGER   'Hvor mange enheder p et flyt
  UnitPerY AS INTEGER   'Hvor mange enheder p et flyt
  MoveX AS INTEGER      'Hvor mange flyt svarer joystickets position til (-3 til 3)
  MoveY AS INTEGER
END TYPE

DIM SHARED rumskib AS SpillerVaesen, Missil(0 TO 14) AS Skud, Ufo(0 TO 9) AS FjendeVaesen
DIM SHARED skudtype(0 TO 7)  AS SkudTyper  '0=laser,1=lille missil,2=store missil
DIM SHARED Eksplosion(0 TO 9)  AS Bang, Grad(0 TO 359)  AS Gradtal
DIM SHARED eksplosionsfarver(0 TO 3, 0 TO 5) AS INTEGER
DIM SHARED bane(1 TO 20) AS level, DropOpGradering(0 TO 2) AS Drops
DIM SHARED Tid AS TidsType, Alfabet(840) AS STRING * 1
DIM SHARED Stjerne(0 TO 39) AS StjerneType, StjerneData(0 TO 3) AS StjerneFartOgFarve
DIM SHARED UfoType(0 TO 3) AS FjendeType, HighScore(0 TO 9) AS HighScoreType
DIM SHARED SkjoldFarver(1 TO 4), joystick AS Joy, LinieStart%

'matricer til rumskibet
DIM SHARED RumskibGetter(0 TO 79)
DIM SHARED RumskibRoedGlimtGetter(0 TO 79)
DIM SHARED RumskibBlaaGlimtGetter(0 TO 79)
DIM SHARED RumskibMaske(0 TO 79)

'matricer til ufo1
DIM SHARED Ufo1Getter(0 TO 99)
DIM SHARED Ufo1GlimtGetter(0 TO 99)
DIM SHARED Ufo1Maske(0 TO 99)

'matricer til ufo2
DIM SHARED Ufo2Getter(0 TO 79)
DIM SHARED Ufo2GlimtGetter(0 TO 79)
DIM SHARED Ufo2Maske(0 TO 79)

'matricer til ufo3
DIM SHARED Ufo3Getter(0 TO 179)
DIM SHARED Ufo3GlimtGetter(0 TO 179)
DIM SHARED Ufo3Maske(0 TO 179)

'matricer til ufo4
DIM SHARED Ufo4Getter(0 TO 374)
DIM SHARED Ufo4GlimtGetter(0 TO 374)
DIM SHARED Ufo4Maske(0 TO 374)

'matricer til det lille missil
DIM SHARED LilleMissilGetter(0 TO 17)
DIM SHARED LilleMissilMaske(0 TO 17)

'matricer til det store missil
DIM SHARED StoreMissilGetter(0 TO 49)
DIM SHARED StoreMissilMaske(0 TO 49)

'matricer til ufobomberne
DIM SHARED UfoBombeGetter(0 TO 8)
DIM SHARED UfoSoegeBombe1Getter(0 TO 8)
DIM SHARED UfoSoegeBombe2Getter(0 TO 8)
DIM SHARED UfoBombeMaske(0 TO 8)

'matricer til Laser Upgrade opsamlingsdimsen
DIM SHARED LaserUpgradeGetter(0 TO 99)

'matricer til Skjold Upgrade opsamlingsdimsen
DIM SHARED SkjoldUpgradeGetter(0 TO 99)

'matricer til Energi Upgrade opsamlingsdimsen
DIM SHARED EnergiUpgradeGetter(0 TO 99)

'matricer til Upgrade masken
DIM SHARED UpgradeMaske(0 TO 99)

'matricer til rumvsen i faldskrm
DIM SHARED RumvaesenIFaldskaermMaske(0 TO 99)
DIM SHARED RumvaesenIFaldskaermGetter(0 TO 99)


COMMON SHARED Tidtager AS DOUBLE, FlytPerGang AS INTEGER, Skaerm AS INTEGER
COMMON SHARED Interval, StartTid, AntalMissilerAfsted, FrameTimer AS DOUBLE
COMMON SHARED SkaermTopMargin, MaxAntalMissilerPaaSkaermen, Pause AS INTEGER
COMMON SHARED AntalEksplosionerPaaSkaermen, MaxAntalEksplosioner, UfoerTilbage AS INTEGER
COMMON SHARED NuvaerendeBane AS INTEGER, Frame AS INTEGER 'til at beregne FPS
COMMON SHARED AntalDropsAfsted AS INTEGER, AntalStjerner AS INTEGER
COMMON SHARED FoersteSpil, StyringMedJoyStick AS STRING * 1, Debug AS INTEGER
COMMON SHARED FilForsoegtAabnet$', ViseSkaerm


CONST viseskaerm = 0
CONST ArbejdsSkaerm = 1
CONST DataSkaerm = 2    'Den skrm som informationer str p (antal liv etc.)
CONST StjerneSkaerm = 3
CONST KollisionsSkaermMedUfoer = 4
CONST KollisionsSkaermMedRumskib = 5
CONST TomSkaerm = 6

ON ERROR GOTO Fejl:     'I fald filen ikke eksisterer oprettes den
FilForsoegtAabnet$ = "HTR.HI"
OPEN FilForsoegtAabnet$ FOR INPUT AS #1
CLOSE #1
VisBSVFil "hvl.bsv"      'Viser titelbillede

HentFont
VaelgStyring
FOR x = 0 TO 7
SCREEN 7, 0, x, x
CLS
NEXT x

InitVar
LavGetPut
LavStjerneMatrice

CheckHiscore "Hent"       'Henter hiscores
NytSpil:

CheckHiscore "NokTilListen"
InitVar
LavStjerneMatrice
Intro
NyBane
DO
  IF StyringMedJoyStick = "T" THEN JoyStickStyring
  Tast$ = UCASE$(INKEY$)
  IF Tast$ <> "" AND Tid.SpilletSlut = "F" THEN CheckTast Tast$
  IF TIMER - Tid.LoekkeStart > Tid.LoekkeInterval THEN
    FlytRumskib
    FlytFjender
    IF AntalDropsAfsted THEN Flytdropopgradering
    Opdaterskaerm
    IF AntalMissilerAfsted THEN
      FlytSkud
    END IF
    CheckTid
    Tid.LoekkeStart = TIMER
  END IF
  IF Tid.StarterNytSpil = "T" THEN GOTO NytSpil
LOOP

StjerneData:
'Stjernefarver og hastigheder
DATA  8, 1
DATA  7, 3
DATA  7, 5
DATA 15, 8

SkjoldData: 'Data til skjoldfarver
DATA 12, 14, 2, 10

'Fejlopsnapperrutine
Fejl:

IF ERR = 53 OR ERR = 52 THEN        'Filen eksisterer ikke
  CLOSE         'Frst lukker vi den bnede fil
  SELECT CASE FilForsoegtAabnet$
    CASE "HTR.HI"  's vi opretter en hiscore-fil
      OPEN "HTR.HI" FOR OUTPUT AS #1
        PRINT #1, "* Dette er hiscore filen til spillet 'Hvl til Rumvsenerne *"
        PRINT #1, "* Et spil af Jakob Krarup *"
        FOR x = 9 TO 0 STEP -1
          PRINT #1, "Jake"
          HighScore(9 - x).Navn = "Jake"
          PRINT #1, (x + 1) * 100
          HighScore(9 - x).Score = (x + 1) * 100
        NEXT x
      CLOSE #1
    CASE ELSE
      SCREEN 12
      CLS
      PRINT "Filen " + FilForsoegtAabnet$ + " blev ikke fundet!"
      PRINT "Programmet afsluttes."
      SLEEP
      END
  END SELECT
  RESUME NEXT
ELSE
 SCREEN 12
 CLS
 LOCATE 3, 15
 COLOR 4
 PRINT "Der er desvrre opstet en uforudset fejl - beklager!"
 COLOR 7
 PRINT
 PRINT "Fejlkoden er :"; ERR
 PRINT
 PRINT "Skriv venligst til mig og fortl mig hvad der skete"
 PRINT
 PRINT " Min e-mail adresse er: 'Jake@post5.tele.dk"
 PRINT
 PRINT "Tryk en tast for at slutte"
 SLEEP
 END
END IF

SUB Center (Tekst$, Linie)

'Denne sub fr en tekststreng og en linie
' tekststrengen skrives centreret p den linie

LOCATE Linie, (40 - LEN(Tekst$)) / 2
PRINT Tekst$

END SUB

SUB CheckHiscore (Handling$)

SELECT CASE Handling$

CASE "Hent"
  OPEN "HTR.HI" FOR INPUT AS #1
    LINE INPUT #1, a$     'Springer over tekstlinierne i highscorefilen
    LINE INPUT #1, a$     'Springer over tekstlinierne i highscorefilen
    FOR x = 9 TO 0 STEP -1
      LINE INPUT #1, a$
      HighScore(9 - x).Navn = a$
      LINE INPUT #1, a$
      HighScore(9 - x).Score = VAL(a$)
    NEXT x
  CLOSE #1
  EXIT SUB

  CASE "NokTilListen"    'Til at checke den nuvrende spillers hiscore
                         'om det er nok til at komme p listen med
                         'Spilleren skal s'fli' heller ikke have snydt!

    IF rumskib.Points >= HighScore(9).Score AND Tid.HarSnydt <> "T" THEN 'Over eller lig den mindste score
      PCOPY StjerneSkaerm, viseskaerm
      SCREEN 7, 0, viseskaerm, viseskaerm
     
      LINE (26, 26)-STEP(269, 149), 1, B        'Ramme
      LINE (24, 24)-STEP(269, 149), 9, B        'Ramme

      LINE (65, 10)-STEP(200, 30), 8, BF        'Overskrift
      LINE (60, 5)-STEP(200, 30), 1, BF
      Xpress "Ny Highscore!!", 75, 12, 13, 2, 1

      Points$ = "* " + LTRIM$(STR$(rumskib.Points)) + " Points! *"
      Xpress Points$, 110, 70, 10, 1, 0
     
      LINE (85, 100)-STEP(159, 13), 1, B        'Ramme om indtastningsfelt
      LINE (86, 99)-STEP(159, 13), 9, B
      Xpress "Indtast dit navn", 110, 130, 2, 1, 0
      GOSUB SkrivTekst
      DO
        Tast$ = INKEY$
        IF LEN(Tast$) = 1 THEN
          IF Tast$ = CHR$(8) THEN 'Backspace
            IF LEN(Navn$) > 1 THEN
              N$ = MID$(Navn$, 1, LEN(Navn$) - 1)
              Navn$ = N$
              Tast$ = ""
            ELSE
              Navn$ = ""
              Tast$ = ""
            END IF
            GOSUB SkrivTekst
          ELSEIF ASC(Tast$) > 31 AND ASC(Tast$) < 173 AND LEN(Navn$) < 13 THEN

            Navn$ = Navn$ + Tast$
            Tast$ = ""
            GOSUB SkrivTekst
          END IF
        END IF
      LOOP WHILE Tast$ <> CHR$(13) OR LEN(Navn$) > 13
      
      '*****************************************************************
      '  Sorterer highscore og gemmer den igen
      '*****************************************************************
      FOR a = 0 TO 8
        IF HighScore(a).Score < rumskib.Points THEN
          FOR x = 8 TO a STEP -1
            SWAP HighScore(x + 1), HighScore(x)
          NEXT x
          EXIT FOR
        END IF
      NEXT a
      HighScore(a).Navn = Navn$
      HighScore(a).Score = rumskib.Points

      KILL "HTR.HI"
      OPEN "HTR.HI" FOR OUTPUT AS #1
        PRINT #1, "* Dette er hiscore filen til spillet 'Hvl til Rumvsenerne *"
        PRINT #1, "* Et spil af Jakob Krarup *"
        FOR x = 10 TO 1 STEP -1
          PRINT #1, HighScore(10 - x).Navn
          PRINT #1, HighScore(10 - x).Score
        NEXT x
      CLOSE #1

    END IF
END SELECT
EXIT SUB

SkrivTekst:
  LINE (100, 101)-STEP(140, 10), 0, BF
  Xpress Navn$, 120, 103, 16, 1, 0
  PUT (120 + 6 * LEN(Navn$), 101), Ufo1Maske, AND
  PUT (120 + 6 * LEN(Navn$), 101), Ufo1Getter, XOR
RETURN

END SUB

SUB CheckTast (Tast$)

SELECT CASE Tast$
 
 
  CASE CHR$(0) + CHR$(35)       'ALT + H til at hoppe til nste bane med
  rumskib.Points = 10000
  CheckHiscore "NokTilListen"

  CASE CHR$(0) + CHR$(48)       'ALT + B til at hoppe til nste bane med
  IF NuvaerendeBane < Tid.AntalBanerIAlt THEN
    NyBane
    Tid.HarSnydt = "T"
  END IF

  CASE CHR$(0) + CHR$(38)       'ALT + L til at opgradere laser med
  rumskib.Laser = rumskib.Laser + 1
  IF rumskib.Laser > 5 THEN rumskib.Laser = 5
  skudtype(0).Skade = skudtype(0).Skade + 10
  Tid.HarSnydt = "T"


  CASE CHR$(0) + CHR$(22)      'ALT + U til at blive Usrlig med
  rumskib.Usaarlig = 1 - rumskib.Usaarlig
  Tid.HarSnydt = "T"

  CASE CHR$(0) + CHR$(31)      'ALT + S til at forge skjold med
  rumskib.Skjold = 100
  IF rumskib.Skjold > 100 THEN rumskib.Skjold = 100
  Tid.HarSnydt = "T"


  CASE CHR$(0) + CHR$(32)      'ALT + D til at sl debug mode til og fra
  Debug = 1 - Debug
  Frame = 0
  FrameTimer = TIMER       'Til at beregne Frames per second med

  CASE "P"      'Laver en pause ved at stte starttid 10 minutter frem
  Pause = 1 - Pause
  IF Pause THEN
    Tid.LoekkeStart = Tid.LoekkeStart + 600   'Venter i 10 minutter
    Tid.PauseStart = TIMER
    SCREEN 7, 0, ArbejdsSkaerm, ArbejdsSkaerm
    LINE (140, 85)-STEP(46, 12), 0, BF
    LINE (140, 85)-STEP(46, 12), 9, B
    LINE (139, 84)-STEP(48, 14), 1, B
    LINE (138, 83)-STEP(50, 16), 9, B
    COLOR 2
    LOCATE 12, 19: PRINT "PAUSE"
  ELSE
    TidGaaetSidenPausensStart = TIMER - Tid.PauseStart
    Tid.LoekkeStart = TIMER
    Tid.BaneStart = Tid.BaneStart + TidGaaetSidenPausensStart
    Tid.NaesteDrop = Tid.NaesteDrop + TidGaaetSidenPausensStart
  END IF

  CASE CHR$(27)         '<esc>
  Tid.StarterNytSpil = "T"
 
  'Skyder lasermissiler afsted
  CASE CHR$(32) 'Space
    SkydLaser


  CASE "Q"      'Skyder de sm missiler
    SkydSmaaMissiler

  CASE "W"      'Skyder de store missiler
    SkydStoreMissiler

  CASE "L"      'bytter tre rumvsener for den store laser
   IF rumskib.AntalRumvaesenerFanget = 3 AND rumskib.Laser = 5 THEN
     rumskib.AntalRumvaesenerFanget = 0
     rumskib.Laser = 15
     skudtype(0).Skade = skudtype(0).Skade + skudtype(0).Skade / 2
   END IF

  'CASE "S"
  ' ViseSkaerm = (ViseSkaerm + 1) MOD 8
  CASE "E"      'Energi - bytter krigsfanger med energi
    IF rumskib.AntalRumvaesenerFanget THEN
      rumskib.AntalRumvaesenerFanget = rumskib.AntalRumvaesenerFanget - 1
      rumskib.Livspoint = rumskib.Livspoint + 50
      IF rumskib.Livspoint > 100 THEN rumskib.Livspoint = 100
    END IF
  CASE CHR$(0) + "K"      'Venstre
  IF rumskib.RetningHV > 0 THEN
    rumskib.RetningHV = 0
  ELSE
    rumskib.RetningHV = rumskib.RetningHV - 3
  END IF
  IF rumskib.RetningHV < -3 THEN rumskib.RetningHV = -3

  CASE CHR$(0) + "M"      'Hjre
  IF rumskib.RetningHV < 0 THEN
    rumskib.RetningHV = 0
  ELSE
    rumskib.RetningHV = rumskib.RetningHV + 3
  END IF
  IF rumskib.RetningHV > 3 THEN rumskib.RetningHV = 3

  CASE CHR$(0) + "H"      'Op
  IF rumskib.RetningOpNed > 0 THEN
    rumskib.RetningOpNed = 0
  ELSE
    rumskib.RetningOpNed = rumskib.RetningOpNed - 3
  END IF
  IF rumskib.RetningOpNed < -3 THEN rumskib.RetningOpNed = -3
 
  CASE CHR$(0) + "P"      'Ned
  IF rumskib.RetningOpNed < 0 THEN
    rumskib.RetningOpNed = 0
  ELSE
    rumskib.RetningOpNed = rumskib.RetningOpNed + 3
  END IF
  IF rumskib.RetningOpNed > 3 THEN rumskib.RetningOpNed = 3

END SELECT

WHILE INKEY$ <> ""
WEND

END SUB

SUB CheckTid

IF Tid.SpilletSlut = "T" THEN
 IF TIMER - Tid.SpilletSluttede > 3 THEN Tid.StarterNytSpil = "T"
ELSEIF Tid.BaneSlut = "T" THEN
  IF Tid.BanenSluttede + 5 < TIMER THEN
    IF Tid.SpilletVundet = "T" THEN
    rumskib.Points = rumskib.Points + Tid.Bonus
    rumskib.Points = rumskib.Points + Tid.TraefBonus
      Tid.StarterNytSpil = "T"
    ELSE
      NyBane
    END IF
  END IF
ELSE
  IF TIMER > Tid.NaesteDrop AND Tid.AntalDropsPaaDenneBane < bane(NuvaerendeBane).AntalDropsPaaDenneBane THEN StartDrop
END IF

STRIG(0) ON
STRIG(4) ON
END SUB

SUB Flytdropopgradering


'gr parat til at checke p rumskibs-kollisionsskrmen
SCREEN 7, 0, KollisionsSkaermMedRumskib, viseskaerm

FOR Taeller = 0 TO 2
  IF DropOpGradering(Taeller).Eksisterer = "T" THEN
  sign = SGN(DropOpGradering(Taeller).RetningOpNed)
    FOR YCheck = sign TO DropOpGradering(Taeller).RetningOpNed STEP sign
      DropOpGradering(Taeller).Y = DropOpGradering(Taeller).Y + sign * FlytPerGang
      IF DropOpGradering(Taeller).Y + DropOpGradering(Taeller).Ystoerrelse > 199 THEN
        DropOpGradering(Taeller).Eksisterer = "F"
        AntalDropsAfsted = AntalDropsAfsted - 1
        EXIT FOR
      ELSE
        FOR x = 0 TO 1
          FOR Y = 0 TO 1
            CheckX = DropOpGradering(Taeller).x + DropOpGradering(Taeller).Xstoerrelse * x
            CheckY = DropOpGradering(Taeller).Y + DropOpGradering(Taeller).Ystoerrelse * Y
            RumskibsPixel = POINT(CheckX, CheckY)
            'Hvis checkpunktet er inden for rumskibet
            IF RumskibsPixel > 0 THEN
           
              SELECT CASE DropOpGradering(Taeller).DropType
                 
                CASE 0        'Hvis det er laseropgradering
                IF rumskib.Laser < 5 THEN
                  rumskib.Laser = rumskib.Laser + 1
                  skudtype(0).Skade = skudtype(0).Skade + 10
                ELSE
                  rumskib.Points = rumskib.Points + NuvaerendeBane * 75
                END IF

                CASE 1        'Hvis det er skjoldopgradering
                 
                  IF rumskib.Skjold < 100 THEN
                    rumskib.Skjold = rumskib.Skjold + 30
                    IF rumskib.Skjold > 100 THEN rumskib.Skjold = 100
                  ELSE
                    rumskib.Points = rumskib.Points + NuvaerendeBane * 75
                  END IF
               
                CASE 2        'Hvis det er energi
                  IF rumskib.Livspoint < 100 THEN
                    rumskib.Livspoint = 100
                  ELSE
                    rumskib.Points = rumskib.Points + NuvaerendeBane * 75
                  END IF
               
                CASE 3        'Hvis det er et rumvsen i faldskrm
                  IF rumskib.AntalRumvaesenerFanget < 3 THEN
                    rumskib.AntalRumvaesenerFanget = rumskib.AntalRumvaesenerFanget + 1
                  ELSE
                    rumskib.Points = rumskib.Points + NuvaerendeBane * 100
                  END IF
              END SELECT
              rumskib.GlimtFarve = 1
              rumskib.GlimtTaeller = 2
              DropOpGradering(Taeller).Eksisterer = "F"
              AntalDropsAfsted = AntalDropsAfsted - 1
              EXIT FOR
            END IF
        NEXT Y, x
      END IF
    NEXT YCheck
  END IF
NEXT Taeller

END SUB

SUB FlytFjender

'Overtegner KollisionsSkaermMedUfoer-skrmen med en sort skrm
PCOPY TomSkaerm, KollisionsSkaermMedUfoer

FOR Vaesen = 0 TO 9
  IF Ufo(Vaesen).Eksisterer = "T" THEN
    IF Ufo(Vaesen).x + Ufo(Vaesen).RetningHV * FlytPerGang < 0 OR Ufo(Vaesen).x + Ufo(Vaesen).RetningHV * FlytPerGang + UfoType(Ufo(Vaesen).UfoType).Xstoerrelse > 320 THEN
      Ufo(Vaesen).RetningHV = Ufo(Vaesen).RetningHV * -1
    END IF
    Ufo(Vaesen).x = Ufo(Vaesen).x + Ufo(Vaesen).RetningHV * FlytPerGang
   
    IF Ufo(Vaesen).Y + Ufo(Vaesen).RetningOpNed * FlytPerGang < SkaermTopMargin OR Ufo(Vaesen).Y + Ufo(Vaesen).RetningOpNed * FlytPerGang + UfoType(Ufo(Vaesen).UfoType).Ystoerrelse - 1 > UfoType(Ufo(Vaesen).UfoType).NedreFlyveGraense THEN
      Ufo(Vaesen).RetningOpNed = Ufo(Vaesen).RetningOpNed * -1
    END IF
   
    Ufo(Vaesen).Y = Ufo(Vaesen).Y + Ufo(Vaesen).RetningOpNed * FlytPerGang

    'Checker om ufoen skal skyde
    IF Ufo(Vaesen).Skyder = "T" THEN
      IF TIMER - Ufo(Vaesen).SidsteSkudTidspunkt > UfoType(Ufo(Vaesen).UfoType).SkyderHvorTit THEN
        IF AntalMissilerAfsted < MaxAntalMissilerPaaSkaermen THEN
          AntalMissilerAfsted = AntalMissilerAfsted + 1
          FOR Taeller = 0 TO AntalMissilerAfsted - 1
            IF Missil(Taeller).Eksisterer = "F" THEN
              Missil(Taeller).skudtype = UfoType(Ufo(Vaesen).UfoType).skudtype
              Missil(Taeller).x = Ufo(Vaesen).x + (UfoType(Ufo(Vaesen).UfoType).Xstoerrelse / 2) - (skudtype(Missil(Taeller).skudtype).Xstoerrelse / 2)
              Missil(Taeller).Y = Ufo(Vaesen).Y + UfoType(Ufo(Vaesen).UfoType).Ystoerrelse
              Missil(Taeller).Eksisterer = "T"
              EXIT FOR
            END IF
          NEXT Taeller
        END IF
        Ufo(Vaesen).SidsteSkudTidspunkt = TIMER
      END IF
    END IF
    'Tegner en kollisionskasse p KollisionsSkaermMedUfoer
    SCREEN 7, 0, KollisionsSkaermMedUfoer, viseskaerm
    LINE (Ufo(Vaesen).x, Ufo(Vaesen).Y)-STEP(UfoType(Ufo(Vaesen).UfoType).Xstoerrelse, UfoType(Ufo(Vaesen).UfoType).Ystoerrelse), Vaesen + 1, BF
  END IF

NEXT Vaesen


END SUB

SUB FlytRumskib

rumskib.GamleX = rumskib.x
rumskib.GamleY = rumskib.Y

rumskib.x = rumskib.x + rumskib.RetningHV * FlytPerGang
rumskib.Y = rumskib.Y + rumskib.RetningOpNed * FlytPerGang

IF rumskib.x + rumskib.Xstoerrelse > 319 THEN
  rumskib.x = 319 - rumskib.Xstoerrelse
  rumskib.RetningHV = 0
ELSEIF rumskib.x < 0 THEN
  rumskib.x = 0
  rumskib.RetningHV = 0
END IF

'**********************************************************************
'Her er det vigtigt at rumskibet aldrig gr lngere ned end lngden af
'det lngste missil - da det ellers bliver puttet nedenfor skrmen!!
'**********************************************************************

IF rumskib.Y + skudtype(2).Ystoerrelse > 199 THEN
  rumskib.Y = 199 - skudtype(2).Ystoerrelse
  rumskib.RetningOpNed = 0
ELSEIF rumskib.Y < SkaermTopMargin THEN
  rumskib.Y = SkaermTopMargin
  rumskib.RetningOpNed = 0
END IF

'*********************************************************************
' Tegner rumskibs kassen til rumskibets kollisionsdetektor skrm
'*********************************************************************

'Overtegner KollisionsSkaermMedRumskib-skrmen med en sort skrm
PCOPY TomSkaerm, KollisionsSkaermMedRumskib


'Skriver derefter en hvid kasse p skrmen der hvor rumskibet er
SCREEN 7, 0, KollisionsSkaermMedRumskib, viseskaerm
LINE (rumskib.x, rumskib.Y)-STEP(rumskib.Xstoerrelse - 1, rumskib.Ystoerrelse - 1), 15, BF



'Dropper kollisionsdetektion hvis spilleren er usaarlig
IF rumskib.Usaarlig = 1 THEN EXIT SUB

'*********************************************************************
'Checker om rumskibet ramler ind i n af ufoerne
'*********************************************************************
'Laver en  imaginr linie mellem rumskibets gamle position og den nye
'og checker et punkt per hastighed +1
'*********************************************************************

'gr parat til at checke p kollisionsskrmen
SCREEN 7, 0, KollisionsSkaermMedUfoer, viseskaerm

'Frst checkes hvilken move der er strst (horisontalt eller vertikalt)

OpNed = ABS(rumskib.RetningOpNed)
HV = ABS(rumskib.RetningHV)

IF OpNed > HV THEN
  StoersteFlyt = OpNed
ELSE
  StoersteFlyt = HV
END IF

'Srger for ikke at dividere med nul
'og opdeler s det flyttede stykke i HV eller OpNed antal stykker
IF HV THEN
  PixelsPerTraekX = (rumskib.RetningHV * FlytPerGang) / HV
ELSE
  PixelsPerTraekX = (rumskib.RetningHV * FlytPerGang)
END IF

IF OpNed THEN
  PixelsPerTraekY = (rumskib.RetningOpNed * FlytPerGang) / OpNed
ELSE
  PixelsPerTraekY = (rumskib.RetningOpNed * FlytPerGang)
END IF

FOR Flyt = 0 TO StoersteFlyt
  CheckX% = rumskib.GamleX + rumskib.Xstoerrelse / 2 + Flyt * PixelsPerTraekX
  CheckY% = rumskib.GamleY + rumskib.Ystoerrelse / 2 + Flyt * PixelsPerTraekY

  Ufo = POINT(CheckX%, CheckY%) - 1
  IF Ufo >= 0 THEN
    IF rumskib.Skjold > 0 THEN        'Der er skjold tilbage
      rumskib.Skjold = rumskib.Skjold - skudtype(Missil(nummer).skudtype).Skade
    ELSE
      rumskib.Livspoint = rumskib.Livspoint - skudtype(Missil(nummer).skudtype).Skade
      IF rumskib.Livspoint <= 0 THEN
        Tid.SpilletSluttede = TIMER
        Tid.SpilletSlut = "T"
      END IF
    END IF
    StartEksplosion CheckX%, CheckY%, 2
    EXIT SUB
  END IF
NEXT Flyt
END SUB

SUB FlytSkud

DIM sign AS INTEGER     'holder -1, 0 eller 1

FOR Taeller = 0 TO MaxAntalMissilerPaaSkaermen - 1
  IF Missil(Taeller).Eksisterer = "T" THEN
    sign = SGN(skudtype(Missil(Taeller).skudtype).RetningOpNed)
    FOR YCheck = sign TO skudtype(Missil(Taeller).skudtype).RetningOpNed STEP sign
      Missil(Taeller).Y = Missil(Taeller).Y + sign * FlytPerGang
      KollisionsCheck Missil(Taeller).skudtype, Taeller, Missil(Taeller).x, Missil(Taeller).Y
      IF Missil(Taeller).Eksisterer = "F" THEN EXIT FOR
    NEXT YCheck
    IF skudtype(Missil(Taeller).skudtype).MaxRetningHV THEN      'Selvsgende missil
      IF Missil(Taeller).x < rumskib.x OR Missil(Taeller).x > rumskib.x + rumskib.Xstoerrelse / 2 THEN
        Missil(Taeller).x = Missil(Taeller).x + SGN((rumskib.x + rumskib.Xstoerrelse / 2) - Missil(Taeller).x) * FlytPerGang * skudtype(Missil(Taeller).skudtype).MaxRetningHV
      END IF
    END IF
    'Checker om skuddet er get uden for skrmen
    'Her checkes top og bund
    IF Missil(Taeller).Y < SkaermTopMargin OR Missil(Taeller).Y + skudtype(Missil(Taeller).skudtype).Ystoerrelse > 199 THEN
      Missil(Taeller).Eksisterer = "F"
      AntalMissilerAfsted = AntalMissilerAfsted - 1
    END IF
    'her checkes siderne
    IF Missil(Taeller).x < 0 THEN
      Missil(Taeller).x = 0
    ELSE
     IF Missil(Taeller).x + skudtype(Missil(Taeller).skudtype).Xstoerrelse - 1 > 319 THEN Missil(Taeller).x = 319 - skudtype(Missil(Taeller).skudtype).Xstoerrelse
    END IF
  END IF
NEXT Taeller


END SUB

SUB HentFont
'FilForsoegtAabnet$ = "FoNT.dat"
'OPEN FilForsoegtAabnet$ FOR BINARY AS #1
'  FOR x = 1 TO 840
'    GET 1, x, Alfabet(x)
'  NEXT x
'CLOSE #1

DEF SEG = VARSEG(Alfabet(0))
BLOAD "font.bsv", VARPTR(Alfabet(0))


END SUB

SUB InitVar

RANDOMIZE TIMER

NuvaerendeBane = 0

IF StyringMedJoyStick = "T" THEN        'Udjvner FPS for styringsformerne
  FlytPerGang = 4
ELSE
  FlytPerGang = 2
END IF

Tid.LoekkeInterval = .04

MaxAntalMissilerPaaSkaermen = 15
MaxAntalEksplosioner = 10
SkaermTopMargin = 18
AntalStjerner = 40

FOR Taeller = 0 TO MaxAntalMissilerPaaSkaermen - 1
  Missil(Taeller).Eksisterer = "F"
NEXT Taeller

OPEN "rumskib.dat" FOR RANDOM AS #1 LEN = LEN(rumskib)
  GET #1, 1, rumskib
CLOSE #1


Tid.HarSnydt = "F"

OPEN "skud.dat" FOR RANDOM AS #1 LEN = LEN(skudtype(1))
  FOR nummer = 0 TO 7
    GET #1, nummer + 1, skudtype(nummer)
  NEXT nummer
CLOSE #1

PI = 3.141592654#

'Lgger X og Y koordinater i matrice til eksplosioner
FOR Grader = 0 TO 359
  radian = Grader * ((2 * PI) / 360)
  Grad(Grader).x = COS(radian)
  Grad(Grader).Y = SIN(radian)
NEXT Grader

OPEN "xplosion.dat" FOR BINARY AS #1
  FOR a = 0 TO 3
    FOR B = 0 TO 5
      GET #1, , eksplosionsfarver(a, B)
  NEXT B, a
CLOSE #1

OPEN "baner.dat" FOR RANDOM AS #1 LEN = LEN(bane(1))
  FOR nummer = 1 TO 15
    GET #1, nummer, bane(nummer)
  NEXT nummer
CLOSE #1

RESTORE StjerneData
FOR x = 0 TO 3
  READ a
  StjerneData(x).farve = a
  READ a
  StjerneData(x).Fart = a
NEXT x
 
FOR Taeller = 0 TO 2
  DropOpGradering(Taeller).Eksisterer = "F"
  DropOpGradering(Taeller).Xstoerrelse = 10
  DropOpGradering(Taeller).Ystoerrelse = 10
  DropOpGradering(Taeller).RetningOpNed = 1
  DropOpGradering(Taeller).RetningHV = 0
  DropOpGradering(Taeller).DropType = 0
NEXT Taeller

OPEN "ufotyper.dat" FOR RANDOM AS #1 LEN = LEN(UfoType(0))
  FOR nummer = 0 TO 3
    GET #1, nummer + 1, UfoType(nummer)
  NEXT nummer
CLOSE #1

Tid.Bonus = 0
Tid.AntalBanerIAlt = 15
rumskib.Points = 0

RESTORE SkjoldData
FOR Skjold = 1 TO 4
  READ SkjoldFarver(Skjold)
NEXT Skjold
END SUB

SUB Intro

DIM Skaermtekst(9) AS STRING
DIM HjaelpeSkaermAktiv AS STRING        'Til at checke om der vises hjaelpeskaerm
DIM JoystickStatus% 'Til at checke om der bliver trykket en knap

HjaelpeSkaermAktiv = "F"
StjerneInterval = .06
SkaermInterval = 5

Skaermtekst(0) = "Hvl til rumvsenerne"
Skaermtekst(1) = "Et Qbasic-spil af Jakob Krarup"
Skaermtekst(2) = "Copyright 1997"
Skaermtekst(3) = "<F1> for hjlp"
Skaermtekst(4) = "<esc> for at slutte"
Skaermtekst(5) = "Andre taster starter spillet"
Skaermtekst(6) = "Ris/Ros til Jake@post5.tele.dk"

'Srger for at der er titel frste gang man starter spillet
IF FoersteSpil THEN
  Tekst = 7
ELSE
  Tekst = 0
END IF


StartTid = TIMER
StjerneStart = TIMER

DO
  IF HjaelpeSkaermAktiv = "F" THEN
    IF TIMER - StartTid > SkaermInterval THEN GOSUB Nytekst
    IF TIMER - StjerneStart > StjerneInterval THEN GOSUB TegnSkaermIgen
  END IF
  IF STRIG(0) OR STRIG(5) THEN  'Hvis der trykkes p joystickknapperne
    FOR Taeller = 0 TO MaxAntalEksplosioner - 1
      Eksplosion(Taeller).Eksisterer = "F"
    NEXT Taeller
    EXIT SUB
  END IF
  Tast$ = INKEY$
 
  IF Tast$ <> "" THEN
   
    SELECT CASE Tast$
      CASE CHR$(0) + CHR$(59)   'F1
        HjaelpeSkaermAktiv = "T"
       
        FilNavn$ = "hvl.txt"

        SCREEN 12
       
        LINE (20, 40)-STEP(600, 390), 3, B
        LINE (20, 13)-STEP(600, 20), 3, B
        LINE (20, 445)-STEP(600, 20), 3, B
        PAINT (1, 1), 8, 3
        LOCATE 29, 15: PRINT "Ls filen med pil op og pil ned.      <esc> afslutter.";
        VisFil FilNavn$
        COLOR 13
        LOCATE 2, 22: PRINT " Hjlpefil til Hvl til Rumvsenerne"
        DO
          DO
          Tast$ = UCASE$(INKEY$)
          LOOP WHILE Tast$ = ""
          DO
          LOOP WHILE INKEY$ <> ""
          IF Tast$ = CHR$(0) + "H" THEN
            LinieStart% = LinieStart% - 1
            IF LinieStart% < 0 THEN LinieStart% = 0
            VisFil FilNavn$
          ELSEIF Tast$ = CHR$(0) + "P" THEN
            LinieStart% = LinieStart% + 1
            VisFil FilNavn$
          ELSEIF Tast$ = CHR$(27) THEN
            HjaelpeSkaermAktiv = "F"
            SCREEN 7, 0, viseskaerm, viseskaerm
            EXIT DO
          END IF
        LOOP

      CASE CHR$(27)             'esc
        IF HjaelpeSkaermAktiv = "T" THEN
          HjaelpeSkaermAktiv = "F"
          Tekst = 0
        ELSE
          SCREEN 0
          WIDTH 80
          PRINT "Tak for spillet!"
          PRINT "Hvl til rumvsenerne version 1.0"
          PRINT
          PRINT

          END
        END IF
      CASE ELSE                 'ellers
        FOR Taeller = 0 TO MaxAntalEksplosioner - 1
          Eksplosion(Taeller).Eksisterer = "F"
        NEXT Taeller
        EXIT SUB
    END SELECT
    
    WHILE INKEY$ <> ""
    WEND
  END IF
LOOP

Nytekst:
    Tekst = (Tekst + 1) MOD 8
    IF Tekst < 7 THEN   'For ikke at f farve 16 (error)
      COLOR Tekst + 9
    ELSE
      COLOR 9
    END IF
    StartTid = TIMER
    FOR x = 0 TO INT(RND * 3)
      StartEksplosion INT(RND * 220) + 50, INT(RND * 160) + 20, 0
    NEXT x
RETURN

TegnSkaermIgen:
  PCOPY StjerneSkaerm, ArbejdsSkaerm 'Overtegner skrmen med en sort skrm
  SCREEN 7, 0, ArbejdsSkaerm, viseskaerm     'Vi tegner til skrm 5
  TegnStjernerTilSkaerm
  IF Tekst < 7 THEN
    LOCATE 12, 20 - LEN(Skaermtekst(Tekst)) / 2 + 1
    PRINT Skaermtekst(Tekst)
  ELSE
    COLOR 5
    LOCATE 2, 16: PRINT "Highscores"
    PUT (90, 8), RumskibMaske, AND
    PUT (90, 8), RumskibGetter, XOR
    PUT (220, 8), RumskibMaske, AND
    PUT (220, 8), RumskibGetter, XOR
    LINE (61, 21)-STEP(199, 175), 0, BF
    LINE (61, 21)-STEP(199, 175), 8, B
    LINE (60, 20)-STEP(199, 175), 7, B
    LINE (59, 19)-STEP(199, 175), 11, B

    FOR x = 0 TO 9
      COLOR (x + 1) MOD 2 + 2
      LOCATE 5 + 2 * x, 15 - LEN(RTRIM$(HighScore(x).Navn)) / 2 + 1: PRINT HighScore(x).Navn
      LOCATE 5 + 2 * x, 25 - LEN(STR$(HighScore(x).Score)) / 2 + 1: PRINT HighScore(x).Score
    NEXT x
  END IF
  TegnEksplosioner
  PCOPY ArbejdsSkaerm, viseskaerm
  StjerneStart = TIMER
RETURN

END SUB

SUB JoystickKalibrering (Maade AS STRING)

SELECT CASE Maade

  CASE "Kalibrr"       'Der skal kalibreres med dette joystick frst

  SCREEN 0
  GOSUB LavTekstFelt
  LOCATE 20, 24: PRINT "Centrr joysticket og tryk knap 1";
  LOCATE 22, 24: PRINT "   (Den knap skyder laseren)";
  DO
  LOOP WHILE STRIG(1) = 0
 
  joystick.CenterX = STICK(0)
  joystick.CenterY = STICK(1)

  GOSUB LavTekstFelt
  COLOR 14, 3
  LOCATE 20, 24: PRINT "Kr joysticket rundt i store cirkler";
  LOCATE 21, 24: PRINT "til de gr vrdier ikke ndrer sig";
  LOCATE 23, 24: PRINT "Centrr s og tryk s p begge knapper! ";
  COLOR 11, 3: LOCATE 1, 1: PRINT "       Joystick Kalibrerings-rutine                                             "
  COLOR 11, 1

  joystick.CurrY = STICK(1)
  joystick.CurrX = STICK(0)

  joystick.MinY = STICK(1)
  joystick.MaxY = STICK(1)

  joystick.MinX = STICK(0)
  joystick.MaxX = STICK(0)

  DO
    joystick.CurrY = STICK(1)
    joystick.CurrX = STICK(0)
    GOSUB CheckJoystickValues
    GOSUB PrintJoystickValues
  LOOP WHILE STRIG(1) = 0 OR STRIG(4) = 0

  joystick.CenterX = (joystick.CenterX + STICK(0)) / 2
  joystick.CenterY = (joystick.CenterY + STICK(1)) / 2
 
  joystick.UnitPerX = (joystick.CenterX - joystick.MinX) / 4
  joystick.UnitPerY = (joystick.CenterY - joystick.MinY) / 4

  CLS
  OPEN "Joystick.stp" FOR OUTPUT AS #1
    PRINT #1, joystick.CenterX
    PRINT #1, joystick.CenterY
    PRINT #1, joystick.UnitPerX
    PRINT #1, joystick.UnitPerY
  CLOSE #1


  CASE "HentFil"
  OPEN "Joystick.stp" FOR INPUT AS #1
    INPUT #1, joystick.CenterX
    INPUT #1, joystick.CenterY
    INPUT #1, joystick.UnitPerX
    INPUT #1, joystick.UnitPerY
  CLOSE #1
 

  END SELECT
EXIT SUB


PrintJoystickValues:
  COLOR 7
  LOCATE 8, 32: PRINT "Minimum Y: "; joystick.MinY
  LOCATE 13, 32: PRINT "Maximum Y: "; joystick.MaxY
  LOCATE 10, 12: PRINT "Minimum X: "; joystick.MinX
  LOCATE 10, 52: PRINT "Maximum X: "; joystick.MaxX
  COLOR 14
  LOCATE 10, 35: PRINT "X: "; joystick.CurrX
  LOCATE 11, 35: PRINT "Y: "; joystick.CurrY
RETURN

CheckJoystickValues:

IF joystick.CurrY < joystick.MinY THEN joystick.MinY = joystick.CurrY
IF joystick.CurrX < joystick.MinX THEN joystick.MinX = joystick.CurrX
IF joystick.CurrY > joystick.MaxY THEN joystick.MaxY = joystick.CurrY
IF joystick.CurrX > joystick.MaxX THEN joystick.MaxX = joystick.CurrX

RETURN


LavTekstFelt:
COLOR 14, 1
CLS
COLOR 14, 3
FOR x = 0 TO 50
  FOR Y = 0 TO 5
    LOCATE 19 + Y, 15 + x: PRINT " ";
NEXT Y, x

RETURN

END SUB

SUB JoyStickStyring


AmountX% = STICK(0) - joystick.CenterX
AmountY% = STICK(1) - joystick.CenterY

rumskib.RetningHV = INT(AmountX% \ joystick.UnitPerX)
rumskib.RetningOpNed = INT(AmountY% \ joystick.UnitPerY)

SkydeCheck% = ABS(STRIG(1) + STRIG(5) * 2)

IF SkydeCheck% = 3 THEN
  SkydStoreMissiler
ELSEIF SkydeCheck% = 2 THEN
  SkydSmaaMissiler
ELSEIF SkydeCheck% = 1 THEN
  SkydLaser
END IF

'       Til at time joystickrutinen med
'JoyTid = TIMER
'SCREEN 7, 0, ViseSkaerm, ViseSkaerm
'LOCATE 5, 5: PRINT TIMER - JoyTid

END SUB

SUB KollisionsCheck (Vaaben%, nummer, SkudX%, SkudY%)

'Vaaben 0= laser, 1 = lille missil, 2 = store missil
' 5= Ufobomber
'Nummer f.eks missil - hvilket nummer?

IF Vaaben% < 5 THEN
  'gr parat til at checke p ufokollisionsskrmen
  SCREEN 7, 0, KollisionsSkaermMedUfoer, viseskaerm
  Ufo = POINT(SkudX%, SkudY%) - 1
  IF Ufo >= 0 AND Ufo(ABS(Ufo)).Eksisterer = "T" THEN
    Missil(nummer).Eksisterer = "F"
    rumskib.SkudRamtMed = rumskib.SkudRamtMed + 1
    AntalMissilerAfsted = AntalMissilerAfsted - 1
    Ufo(Ufo).Livspoint = Ufo(Ufo).Livspoint - skudtype(Missil(nummer).skudtype).Skade
    Ufo(Ufo).GlimtTaeller = 2        'I to frames
    IF Ufo(Ufo).Livspoint <= 0 THEN
      Ufo(Ufo).Eksisterer = "F"
      rumskib.Points = rumskib.Points + UfoType(Ufo(Ufo).UfoType).Points
      UfoerTilbage = UfoerTilbage - 1
      IF UfoerTilbage <= 0 THEN
        Tid.BaneSlut = "T"
        rumskib.TraefProcent = INT((rumskib.SkudRamtMed / rumskib.SkudSkudt) * 100)
        Tid.BanenSluttede = TIMER
        IF NuvaerendeBane >= Tid.AntalBanerIAlt THEN Tid.SpilletVundet = "T"
      ELSE
        IF RND * 100 < 8 THEN  '10 % chance for at rumvsenet hopper ud med faldskrm
          'S sttes der en faldskrm af
          IF AntalDropsAfsted < 3 THEN
            FOR Taeller = 0 TO 2
              IF DropOpGradering(Taeller).Eksisterer = "F" THEN
                DropOpGradering(Taeller).Eksisterer = "T"
                DropOpGradering(Taeller).DropType = 3
                DropOpGradering(Taeller).RetningOpNed = 1
                DropOpGradering(Taeller).x = Ufo(Ufo).x
                DropOpGradering(Taeller).Y = Ufo(Ufo).Y
                AntalDropsAfsted = AntalDropsAfsted + 1
                EXIT FOR
              END IF
            NEXT Taeller
          END IF
        END IF
      END IF
    END IF
    StartEksplosion SkudX%, SkudY%, Vaaben%
    EXIT SUB
  END IF
ELSE
  'S er det fjendens ammo
  IF rumskib.Livspoint > 0 AND rumskib.Usaarlig = 0 THEN
    'gr parat til at checke p rumskibs-kollisionsskrmen
    SCREEN 7, 0, KollisionsSkaermMedRumskib, viseskaerm
    RumskibsPixel = POINT(SkudX%, SkudY%)
    'Hvis checkpunktet er inden for rumskibet
    IF RumskibsPixel > 0 THEN
      Missil(nummer).Eksisterer = "F"
      AntalMissilerAfsted = AntalMissilerAfsted - 1
      IF rumskib.Skjold > 0 THEN        'Der er skjold tilbage
        rumskib.Skjold = rumskib.Skjold - skudtype(Missil(nummer).skudtype).Skade
        rumskib.GlimtFarve = 1          'Der sttes et rdt glimt i gang
        rumskib.GlimtTaeller = 1        'I en frame
      ELSE
        rumskib.GlimtFarve = 4          'Der sttes et rdt glimt i gang
        rumskib.GlimtTaeller = 2        'I to frames
        StartEksplosion SkudX%, SkudY%, Vaaben%         'Og en eksplosion
        rumskib.Livspoint = rumskib.Livspoint - skudtype(Missil(nummer).skudtype).Skade
        IF rumskib.Livspoint <= 0 THEN
          Tid.SpilletSluttede = TIMER
          Tid.SpilletSlut = "T"
        END IF
      END IF
    END IF
  END IF
END IF

END SUB

SUB LavGetPut
DIM char AS STRING * 1
SCREEN 7, 0, viseskaerm, viseskaerm
COLOR 9
LOCATE 12, 14: PRINT "Laver grafik"

RESTORE
SCREEN 7, 0, StjerneSkaerm, viseskaerm

'*********************************************************************
'laver og getter rumskib
'*********************************************************************
CLS
OPEN "sprites.dat" FOR BINARY AS #1

FOR Y = 0 TO rumskib.Ystoerrelse - 1
  FOR x = 0 TO rumskib.Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(rumskib.Xstoerrelse - 1, rumskib.Ystoerrelse - 1), RumskibGetter

CLS
FOR Y = 0 TO rumskib.Ystoerrelse - 1
  FOR x = 0 TO rumskib.Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(rumskib.Xstoerrelse - 1, rumskib.Ystoerrelse - 1), RumskibBlaaGlimtGetter

CLS
FOR Y = 0 TO rumskib.Ystoerrelse - 1
  FOR x = 0 TO rumskib.Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(rumskib.Xstoerrelse - 1, rumskib.Ystoerrelse - 1), RumskibRoedGlimtGetter


CLS
FOR Y = 0 TO rumskib.Ystoerrelse - 1
  FOR x = 0 TO rumskib.Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(rumskib.Xstoerrelse - 1, rumskib.Ystoerrelse - 1), RumskibMaske

'*********************************************************************
'Laver det lille missil og lgger det i maske og sprite matricerne
'*********************************************************************

CLS

FOR Y = 0 TO skudtype(1).Ystoerrelse - 1
  FOR x = 0 TO skudtype(1).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(2, 5), LilleMissilGetter
CLS

FOR Y = 0 TO skudtype(1).Ystoerrelse - 1
  FOR x = 0 TO skudtype(1).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(2, 5), LilleMissilMaske

'*********************************************************************
'Laver det store missil og lgger det i maske og sprite matricerne
'*********************************************************************

FOR Y = 0 TO skudtype(2).Ystoerrelse - 1
  FOR x = 0 TO skudtype(2).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(skudtype(2).Xstoerrelse - 1, skudtype(2).Ystoerrelse - 1), StoreMissilGetter

CLS

FOR Y = 0 TO skudtype(2).Ystoerrelse - 1
  FOR x = 0 TO skudtype(2).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(skudtype(2).Xstoerrelse - 1, skudtype(2).Ystoerrelse - 1), StoreMissilMaske

'*********************************************************************
'laver og getter ufo 1
'*********************************************************************
CLS
FOR Y = 0 TO UfoType(Ufo(0).UfoType).Ystoerrelse - 1
  FOR x = 0 TO UfoType(Ufo(0).UfoType).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(UfoType(Ufo(0).UfoType).Xstoerrelse - 1, UfoType(Ufo(0).UfoType).Ystoerrelse - 1), Ufo1Getter

CLS
FOR Y = 0 TO UfoType(Ufo(0).UfoType).Ystoerrelse - 1
  FOR x = 0 TO UfoType(Ufo(0).UfoType).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(UfoType(Ufo(0).UfoType).Xstoerrelse - 1, UfoType(Ufo(0).UfoType).Ystoerrelse - 1), Ufo1GlimtGetter


CLS

FOR Y = 0 TO UfoType(Ufo(0).UfoType).Ystoerrelse - 1
  FOR x = 0 TO UfoType(Ufo(0).UfoType).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(UfoType(Ufo(0).UfoType).Xstoerrelse - 1, UfoType(Ufo(0).UfoType).Ystoerrelse - 1), Ufo1Maske

'*********************************************************************
'laver og getter ufo 2
'*********************************************************************
CLS
FOR Y = 0 TO UfoType(1).Ystoerrelse - 1
  FOR x = 0 TO UfoType(1).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(UfoType(1).Xstoerrelse - 1, UfoType(1).Ystoerrelse - 1), Ufo2Getter

CLS
FOR Y = 0 TO UfoType(1).Ystoerrelse - 1
  FOR x = 0 TO UfoType(1).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(UfoType(1).Xstoerrelse - 1, UfoType(1).Ystoerrelse - 1), Ufo2GlimtGetter

CLS

FOR Y = 0 TO UfoType(1).Ystoerrelse - 1
  FOR x = 0 TO UfoType(1).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(UfoType(1).Xstoerrelse - 1, UfoType(1).Ystoerrelse - 1), Ufo2Maske

'*********************************************************************
'laver og getter ufo 3
'*********************************************************************

CLS
FOR Y = 0 TO UfoType(2).Ystoerrelse - 1
  FOR x = 0 TO UfoType(2).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(UfoType(2).Xstoerrelse - 1, UfoType(2).Ystoerrelse - 1), Ufo3Getter

CLS
FOR Y = 0 TO UfoType(2).Ystoerrelse - 1
  FOR x = 0 TO UfoType(2).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(UfoType(2).Xstoerrelse - 1, UfoType(2).Ystoerrelse - 1), Ufo3GlimtGetter

CLS

FOR Y = 0 TO UfoType(2).Ystoerrelse - 1
  FOR x = 0 TO UfoType(2).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(UfoType(2).Xstoerrelse - 1, UfoType(2).Ystoerrelse - 1), Ufo3Maske

'*********************************************************************
'laver og getter ufo 4
'*********************************************************************

CLS
FOR Y = 0 TO UfoType(3).Ystoerrelse - 1
  FOR x = 0 TO UfoType(3).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(UfoType(3).Xstoerrelse - 1, UfoType(3).Ystoerrelse - 1), Ufo4Getter

CLS
FOR Y = 0 TO UfoType(3).Ystoerrelse - 1
  FOR x = 0 TO UfoType(3).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(UfoType(3).Xstoerrelse - 1, UfoType(3).Ystoerrelse - 1), Ufo4GlimtGetter

CLS

FOR Y = 0 TO UfoType(3).Ystoerrelse - 1
  FOR x = 0 TO UfoType(3).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(UfoType(3).Xstoerrelse - 1, UfoType(3).Ystoerrelse - 1), Ufo4Maske



'*********************************************************************
'laver og getter ufobomberne
'*********************************************************************

CLS
FOR Y = 0 TO skudtype(5).Ystoerrelse - 1
  FOR x = 0 TO skudtype(5).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(skudtype(5).Xstoerrelse - 1, skudtype(5).Ystoerrelse - 1), UfoBombeGetter

CLS
FOR Y = 0 TO skudtype(6).Ystoerrelse - 1
  FOR x = 0 TO skudtype(6).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(skudtype(6).Xstoerrelse - 1, skudtype(6).Ystoerrelse - 1), UfoSoegeBombe1Getter

CLS
FOR Y = 0 TO skudtype(7).Ystoerrelse - 1
  FOR x = 0 TO skudtype(7).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(skudtype(7).Xstoerrelse - 1, skudtype(7).Ystoerrelse - 1), UfoSoegeBombe2Getter

CLS

FOR Y = 0 TO skudtype(5).Ystoerrelse - 1
  FOR x = 0 TO skudtype(5).Xstoerrelse - 1
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(skudtype(5).Xstoerrelse - 1, skudtype(5).Ystoerrelse - 1), UfoBombeMaske

'*********************************************************************
'laver og getter sprites til LaserUpgrades
'*********************************************************************

CLS
FOR Y = 0 TO 9
  FOR x = 0 TO 9
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(9, 9), LaserUpgradeGetter

'*********************************************************************
'laver og getter sprites til SkjoldUpgrades
'*********************************************************************

CLS
FOR Y = 0 TO 9
  FOR x = 0 TO 9
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(9, 9), SkjoldUpgradeGetter

'*********************************************************************
'laver og getter sprites til EnergiUpgrades
'*********************************************************************

CLS
FOR Y = 0 TO 9
  FOR x = 0 TO 9
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(9, 9), EnergiUpgradeGetter

'*********************************************************************
'laver og getter sprites til UpgradeMasken
'*********************************************************************

CLS
FOR Y = 0 TO 9
  FOR x = 0 TO 9
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(9, 9), UpgradeMaske

'*********************************************************************
'laver og getter sprites til Rumvsener i faldskrm
'*********************************************************************

CLS
FOR Y = 0 TO 9
  FOR x = 0 TO 9
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
    NEXT x, Y

GET (0, 0)-STEP(9, 9), RumvaesenIFaldskaermGetter

CLS
FOR Y = 0 TO 9
  FOR x = 0 TO 9
      GET #1, , pixel
      PSET (x, Y), INT(pixel)
NEXT x, Y

GET (0, 0)-STEP(9, 9), RumvaesenIFaldskaermMaske

CLOSE #1
END SUB

SUB LavStjerneMatrice


SCREEN 7, 0, StjerneSkaerm, viseskaerm
CLS

FOR Taeller = 0 TO 100
  PSET (INT(RND * 320), INT(RND * (200))), 8
NEXT Taeller

FOR Taeller = 0 TO AntalStjerner - 1
  Tilfaeldig = INT(RND * 100)
  IF Tilfaeldig < 40 THEN
    lag = 0
  ELSEIF Tilfaeldig < 60 THEN
   lag = 1
  ELSEIF Tilfaeldig < 80 THEN
   lag = 2
  ELSE
   lag = 3
  END IF
  Stjerne(Taeller).x = INT(RND * 320)
  Stjerne(Taeller).Y = INT(RND * (200 - SkaermTopMargin))
  Stjerne(Taeller).lag = lag
NEXT Taeller

END SUB

SUB NyBane

FoersteSpil = 1 'Srger for at der vises highscore liste efter spillet
AntalMissilerAfsted = 0

FOR Taeller = 0 TO MaxAntalMissilerPaaSkaermen - 1
  Missil(Taeller).Eksisterer = "F"
NEXT Taeller

NuvaerendeBane = NuvaerendeBane + 1

Tid.BaneStart = TIMER
Tid.BaneSlut = "F"
Tid.SpilletSlut = "F"
Tid.SpilletVundet = "F"
Tid.StarterNytSpil = "F"
Tid.AntalDropsPaaDenneBane = 0

IF bane(NuvaerendeBane).AntalDropsPaaDenneBane THEN
  Tid.NaesteDrop = TIMER + 15 * RND + 15
END IF

IF bane(NuvaerendeBane).NytLiv = "T" THEN rumskib.Livspoint = 100

rumskib.StoreMissiler = rumskib.StoreMissiler + bane(NuvaerendeBane).AntalStoreMissiler
rumskib.SmaaMissiler = rumskib.SmaaMissiler + bane(NuvaerendeBane).AntalSmaaMissiler
rumskib.Points = rumskib.Points + Tid.TraefBonus
rumskib.Points = rumskib.Points + Tid.Bonus
rumskib.SkudSkudt = 0
rumskib.SkudRamtMed = 0
rumskib.TraefProcent = 0

FOR Taeller = 0 TO 9
  Ufo(Taeller).Eksisterer = "F"
NEXT Taeller

UfoerTilbage = bane(NuvaerendeBane).AntalUfoerIalt

FOR Taeller = 0 TO UfoerTilbage - 1
  Ufo(Taeller).Eksisterer = "T"
  Ufo(Taeller).UfoType = bane(NuvaerendeBane).UfoType
  Ufo(Taeller).x = 50 + INT(RND * 220)
  Ufo(Taeller).Y = SkaermTopMargin + INT(RND * 20)
  Ufo(Taeller).Livspoint = UfoType(Ufo(Taeller).UfoType).Livspoint
  Ufo(Taeller).SidsteSkudTidspunkt = TIMER + INT(RND * UfoType(Ufo(Taeller).UfoType).SkyderHvorTit - 2)
  Ufo(Taeller).GlimtTaeller = 0
  DO
    Ufo(Taeller).RetningOpNed = INT(RND * 5) - 2
    Ufo(Taeller).RetningHV = INT(RND * 5) - 2
  LOOP WHILE Ufo(Taeller).RetningOpNed * Ufo(Taeller).RetningHV = 0
  Ufo(Taeller).Skyder = "T"
NEXT Taeller


END SUB

SUB Opdaterskaerm

SCREEN 7, 0, ArbejdsSkaerm, viseskaerm     'Vi tegner til skrm 1

PCOPY StjerneSkaerm, ArbejdsSkaerm 'Overtegner arbejdsskrmen med stjerneskrmen
StjerneYOffset = StjerneYOffset + 1
TegnStjernerTilSkaerm



IF Debug THEN
  Frame = Frame + 1       'Til at beregne Frames per second med
  LOCATE 19, 30: PRINT "FPS"; INT(Frame / ((TIMER + 1) - FrameTimer))
  LOCATE 20, 30: PRINT "Bane"; NuvaerendeBane;
  LOCATE 21, 30: PRINT "Ufoer"; UfoerTilbage;
  LOCATE 22, 25: PRINT "Fri mem"; FRE(-1);
END IF


'****************************************************************************
'Opdaterer databjaelken verst i skrmen
'****************************************************************************

XOffsetForLaserEnergi = 60

LINE (5, 6)-STEP(308, 11), 0, BF
LINE (6, 6)-STEP(308, 12), 8, B
LINE (5, 6)-STEP(308, 11), 7, B

COLOR 8
LOCATE 2, 2
PRINT rumskib.Points;
PRINT "Points";

COLOR 8
LOCATE 2, 36
PRINT ":" + LTRIM$(STR$(rumskib.StoreMissiler));
PUT (273, 7), StoreMissilMaske, AND
PUT (273, 7), StoreMissilGetter, XOR

LOCATE 2, 31
PRINT ":" + LTRIM$(STR$(rumskib.SmaaMissiler));
PUT (234, 9), LilleMissilMaske, AND
PUT (234, 9), LilleMissilGetter, XOR

'Skriver resterende tid
IF Tid.BaneSlut = "F" THEN
  Bonus$ = STR$(INT(((Tid.BaneStart - TIMER) + 60)) * NuvaerendeBane * 5)
  IF Bonus <= 0 THEN Tid.Bonus = VAL(Bonus$)
ELSE
  Bonus$ = STR$(Tid.Bonus)
END IF
IF VAL(Bonus$) < 0 THEN Bonus$ = "0"
LOCATE 2, 17: PRINT "Bonus:" + Bonus$

'****************************************************************************
'Tegner energibjlker
'****************************************************************************

AntalLaserEnergipunkter = 55 * rumskib.LaserEnergi / 100

FOR YPunkt = 0 TO AntalLaserEnergipunkter
  LINE (3, 190 - YPunkt * 3)-STEP(3, -3), 4
NEXT YPunkt

AntalLivsPointpunkter = 55 * rumskib.Livspoint / 100

FOR YPunkt = 0 TO AntalLivsPointpunkter
  LINE (9, 190 - YPunkt * 3)-STEP(3, -3), 2
NEXT YPunkt

'****************************************************************************
'Tegner energibjlker for ufo type 4 - hvis der er nogen
'****************************************************************************

IF Ufo(0).UfoType = 3 THEN
  AntalLivsPointpunkter = 55 * (Ufo(0).Livspoint / 1500)
  FOR YPunkt = 0 TO AntalLivsPointpunkter
    LINE (310, 190 - YPunkt * 3)-STEP(3, -3), 5
  NEXT YPunkt
END IF

IF Tid.BaneSlut = "T" THEN
 
  Tid.TraefBonus = INT(VAL(Bonus$) * rumskib.TraefProcent / 100)
  IF Tid.SpilletVundet <> "T" THEN
    COLOR 2
    Center "Banen gennemfrt!", 10
    COLOR 9
    Center "Tidsbonus:" + Bonus$, 12
    Center "Trfprocent:" + STR$(rumskib.TraefProcent) + "%", 14
    Center "Trfbonus:" + Bonus$ + " x" + STR$(rumskib.TraefProcent) + "% =" + STR$(Tid.TraefBonus), 16
    Center "Bonus i alt:" + STR$(Tid.TraefBonus + VAL(Bonus$)), 18
  ELSE
    COLOR 2
    LOCATE 13, 16: PRINT "Du vandt!!"
    COLOR 7
    LOCATE 15, 11: PRINT "Hvl til Rumvsenerne!"
  END IF
END IF

IF Tid.HarSnydt = "T" THEN COLOR 4: LOCATE 24, 32: PRINT "SNYDER!";

IF Tid.SpilletSlut = "T" THEN
  COLOR 10
  LOCATE 12, 13: PRINT "Spillet er slut"
END IF

IF AntalEksplosionerPaaSkaermen THEN TegnEksplosioner

IF AntalMissilerAfsted THEN TegnSprite 1 'Tegner missiler til  til skrm 5

IF rumskib.Livspoint > 0 THEN TegnSprite 0 'Sender rumskibet til ArbejdsSkaerm
TegnSprite 2
TegnSprite 3    'drops
TegnSprite 5

'Tegner de tilfangetagne rumvaesener
IF rumskib.AntalRumvaesenerFanget THEN
  FOR x = 0 TO rumskib.AntalRumvaesenerFanget - 1
    PUT (300 - x * 15, 180), RumvaesenIFaldskaermMaske, AND
    PUT (300 - x * 15, 180), RumvaesenIFaldskaermGetter, XOR
  NEXT x
END IF

PCOPY ArbejdsSkaerm, viseskaerm    'Vi kopierer arbejdssiden til 0
'Med linien herunder af-'et kan man se kollisionsskrmen
'PCOPY KollisionsSkaermMedUfoer, ViseSkaerm    'Vi kopierer arbejdssiden til 0

'Genoplader laserbatteriet
Opladning = rumskib.LaserEnergi \ 40 + 1
rumskib.LaserEnergi = rumskib.LaserEnergi + Opladning
IF rumskib.LaserEnergi > 100 THEN rumskib.LaserEnergi = 100

END SUB

SUB SkydLaser

    IF AntalMissilerAfsted < MaxAntalMissilerPaaSkaermen AND rumskib.LaserEnergi > rumskib.EnergiPerLaserSkud THEN
      AntalMissilerAfsted = AntalMissilerAfsted + 1
      IF Tid.BaneSlut = "F" THEN rumskib.SkudSkudt = rumskib.SkudSkudt + 1
      FOR Taeller = 0 TO AntalMissilerAfsted - 1
        IF Missil(Taeller).Eksisterer = "F" THEN
          IF rumskib.SidsteLaserAfskudt = 0 THEN
            Missil(Taeller).x = rumskib.x + rumskib.LaserXOffset0
          ELSE
            Missil(Taeller).x = rumskib.x + rumskib.LaserXOffset1
          END IF
          Missil(Taeller).Y = rumskib.Y
          rumskib.LaserEnergi = rumskib.LaserEnergi - rumskib.EnergiPerLaserSkud
          rumskib.SidsteLaserAfskudt = 1 - rumskib.SidsteLaserAfskudt
          Missil(Taeller).skudtype = 0
          Missil(Taeller).Eksisterer = "T"
          EXIT FOR
        END IF
      NEXT Taeller
    END IF


END SUB

SUB SkydSmaaMissiler
 
  IF AntalMissilerAfsted < MaxAntalMissilerPaaSkaermen AND rumskib.SmaaMissiler > 0 THEN
    IF Tid.BaneSlut = "F" THEN rumskib.SkudSkudt = rumskib.SkudSkudt + 1
    rumskib.SmaaMissiler = rumskib.SmaaMissiler - 1
    AntalMissilerAfsted = AntalMissilerAfsted + 1
    FOR Taeller = 0 TO AntalMissilerAfsted - 1
      IF Missil(Taeller).Eksisterer = "F" THEN
        Missil(Taeller).skudtype = 1
        Missil(Taeller).x = rumskib.x + (rumskib.Xstoerrelse / 2) - (skudtype(Missil(Taeller).skudtype).Xstoerrelse / 2)
        Missil(Taeller).Y = rumskib.Y
        Missil(Taeller).Eksisterer = "T"
        EXIT FOR
      END IF
    NEXT Taeller
  END IF

END SUB

SUB SkydStoreMissiler

  IF AntalMissilerAfsted < MaxAntalMissilerPaaSkaermen AND rumskib.StoreMissiler > 0 THEN
    IF Tid.BaneSlut = "F" THEN rumskib.SkudSkudt = rumskib.SkudSkudt + 1
    AntalMissilerAfsted = AntalMissilerAfsted + 1
    rumskib.StoreMissiler = rumskib.StoreMissiler - 1
    FOR Taeller = 0 TO AntalMissilerAfsted - 1
      IF Missil(Taeller).Eksisterer = "F" THEN
        Missil(Taeller).skudtype = 2
        Missil(Taeller).x = rumskib.x + (rumskib.Xstoerrelse / 2) - (skudtype(Missil(Taeller).skudtype).Xstoerrelse / 2)
        Missil(Taeller).Y = rumskib.Y
        Missil(Taeller).Eksisterer = "T"
        EXIT FOR
      END IF
    NEXT Taeller
  END IF

END SUB

SUB StartDrop

'srger for at 2/3 af dropsene er skjold
Slag = INT(RND * 10)
IF Slag <= 2 THEN
  DropType = 0
ELSEIF Slag <= 6 THEN
  DropType = 1
ELSE
  DropType = 2
END IF

FOR x = 0 TO 2
  IF DropOpGradering(x).Eksisterer = "F" THEN
    AntalDropsAfsted = AntalDropsAfsted + 1
    DropOpGradering(x).x = INT(RND * 309)
    DropOpGradering(x).Y = 1
    DropOpGradering(x).Eksisterer = "T"
    DropOpGradering(x).DropType = DropType
    Tid.NaesteDrop = TIMER + 15 * RND + 15
    Tid.AntalDropsPaaDenneBane = Tid.AntalDropsPaaDenneBane + 1
    EXIT FOR
  END IF
NEXT x
END SUB

SUB StartEksplosion (SkudX%, SkudY%, Vaaben%)

IF AntalEksplosionerPaaSkaermen < MaxAntalEksplosioner THEN
  FOR Taeller = 0 TO MaxAntalEksplosioner - 1
    IF Eksplosion(Taeller).Eksisterer <> "T" THEN
      Eksplosion(Taeller).x = SkudX%
      Eksplosion(Taeller).Y = SkudY%
      SELECT CASE Vaaben%
        CASE 0
          Eksplosion(Taeller).Varighed = 10
          Eksplosion(Taeller).AntalGnister = 10
          Eksplosion(Taeller).Eksisterer = "T"
          Eksplosion(Taeller).Alder = 0
          Eksplosion(Taeller).farve = Vaaben%
        CASE 1
          Eksplosion(Taeller).Varighed = 15
          Eksplosion(Taeller).AntalGnister = 20
          Eksplosion(Taeller).Eksisterer = "T"
          Eksplosion(Taeller).Alder = 0
          Eksplosion(Taeller).farve = Vaaben%
        CASE 2
          Eksplosion(Taeller).Varighed = 25
          Eksplosion(Taeller).AntalGnister = 15
          Eksplosion(Taeller).Eksisterer = "T"
          Eksplosion(Taeller).Alder = 0
          Eksplosion(Taeller).farve = Vaaben%
        CASE ELSE
          Eksplosion(Taeller).Varighed = 25
          Eksplosion(Taeller).AntalGnister = 20
          Eksplosion(Taeller).Eksisterer = "T"
          Eksplosion(Taeller).Alder = 0
          Eksplosion(Taeller).farve = 3
        END SELECT
        AntalEksplosionerPaaSkaermen = AntalEksplosionerPaaSkaermen + 1
        EXIT SUB
      END IF
    NEXT Taeller
  END IF
END SUB

SUB TegnEksplosioner

SCREEN 7, 0, ArbejdsSkaerm, viseskaerm
FOR Taeller = 0 TO MaxAntalEksplosioner - 1
  IF Eksplosion(Taeller).Eksisterer = "T" THEN
    FOR Gradtal = 0 TO 359 STEP (360 / Eksplosion(Taeller).AntalGnister)
      x = Grad(Gradtal).x * Eksplosion(Taeller).Alder
      Y = Grad(Gradtal).Y * Eksplosion(Taeller).Alder
      PSET (Eksplosion(Taeller).x + x * 3, Eksplosion(Taeller).Y + Y * 3), eksplosionsfarver(Eksplosion(Taeller).farve, INT(RND * 6))
      PSET (Eksplosion(Taeller).x + x * 2, Eksplosion(Taeller).Y + Y * 2), eksplosionsfarver(Eksplosion(Taeller).farve, INT(RND * 6))
    NEXT Gradtal

    Eksplosion(Taeller).Alder = Eksplosion(Taeller).Alder + 1
    IF Eksplosion(Taeller).Alder > Eksplosion(Taeller).Varighed THEN
      Eksplosion(Taeller).Eksisterer = "F"
      AntalEksplosionerPaaSkaermen = AntalEksplosionerPaaSkaermen - 1
    END IF
  END IF
NEXT Taeller
END SUB

SUB TegnSprite (Sprite)

'Hvis sprite  = 0 then tegn rumskib
SELECT CASE Sprite
  CASE 0
    MidtX = rumskib.x + rumskib.Xstoerrelse / 2 'Beregner rumskibets midtpunkt
    MidtY = rumskib.Y + rumskib.Ystoerrelse / 2
    PUT (rumskib.x, rumskib.Y), RumskibMaske, AND
    IF rumskib.GlimtTaeller THEN
      SELECT CASE rumskib.GlimtFarve   'Laver en enkelt frames glimt i nsket farve
        CASE 1    'Bl - ved opsamling af drops
          PUT (rumskib.x, rumskib.Y), RumskibBlaaGlimtGetter, XOR
        CASE 4    'Rd - ved skade
          PUT (rumskib.x, rumskib.Y), RumskibRoedGlimtGetter, XOR
      END SELECT
      rumskib.GlimtTaeller = rumskib.GlimtTaeller - 1
    ELSE
      PUT (rumskib.x, rumskib.Y), RumskibGetter, XOR
    END IF
    farve = INT(3 * (rumskib.Skjold / 101)) + 1
    IF rumskib.Skjold > 0 THEN
      FOR Gradtal = 90 TO 270 STEP INT(RND * 5) + 10
        x = Grad(Gradtal).Y * 12 + MidtX
        Y = Grad(Gradtal).x * 12 + MidtY
        PSET (x, Y), SkjoldFarver(farve + INT(RND * 2))
      NEXT Gradtal
    END IF
 
  'Hvis sprite  = 1 then tegn missil
  CASE 1
 
  FOR Taeller = 0 TO MaxAntalMissilerPaaSkaermen - 1
    IF Missil(Taeller).Eksisterer = "T" THEN
      SELECT CASE Missil(Taeller).skudtype
        CASE 0
          IF rumskib.Laser < 15 THEN    'Hvis man ikke har superlaseren
            LINE (Missil(Taeller).x, Missil(Taeller).Y)-STEP(0, skudtype(Missil(Taeller).skudtype).Ystoerrelse), rumskib.Laser
            LINE (Missil(Taeller).x, Missil(Taeller).Y)-STEP(0, 3), rumskib.Laser + 8
            PSET (Missil(Taeller).x, Missil(Taeller).Y), 15
          ELSE
            LINE (Missil(Taeller).x, Missil(Taeller).Y)-STEP(0, skudtype(Missil(Taeller).skudtype).Ystoerrelse), 15
            'LINE (Missil(Taeller).X, Missil(Taeller).Y)-STEP(0, 3), 1
            PSET (Missil(Taeller).x, Missil(Taeller).Y - 2), 15
          END IF
        CASE 1
          PUT (Missil(Taeller).x, Missil(Taeller).Y), LilleMissilMaske, AND
          PUT (Missil(Taeller).x, Missil(Taeller).Y), LilleMissilGetter, XOR
        CASE 2
          PUT (Missil(Taeller).x, Missil(Taeller).Y), StoreMissilMaske, AND
          PUT (Missil(Taeller).x, Missil(Taeller).Y), StoreMissilGetter, XOR
        CASE 5
          PUT (Missil(Taeller).x, Missil(Taeller).Y), UfoBombeMaske, AND
          PUT (Missil(Taeller).x, Missil(Taeller).Y), UfoBombeGetter, XOR
        CASE 6
          PUT (Missil(Taeller).x, Missil(Taeller).Y), UfoBombeMaske, AND
          PUT (Missil(Taeller).x, Missil(Taeller).Y), UfoSoegeBombe1Getter, XOR
        CASE 7
          PUT (Missil(Taeller).x, Missil(Taeller).Y), UfoBombeMaske, AND
          PUT (Missil(Taeller).x, Missil(Taeller).Y), UfoSoegeBombe2Getter, XOR
      END SELECT
    END IF
  NEXT Taeller

  CASE 2
  FOR Vaesen = 0 TO 9
    IF Ufo(Vaesen).Eksisterer = "T" THEN
      IF Debug THEN LINE (Ufo(Vaesen).x, Ufo(Vaesen).Y)-STEP(UfoType(Ufo(Vaesen).UfoType).Xstoerrelse, UfoType(Ufo(Vaesen).UfoType).Ystoerrelse), Vaesen, BF
      SELECT CASE Ufo(Vaesen).UfoType
      CASE 0
        PUT (Ufo(Vaesen).x, Ufo(Vaesen).Y), Ufo1Maske, AND
        IF Ufo(Vaesen).GlimtTaeller THEN
          PUT (Ufo(Vaesen).x, Ufo(Vaesen).Y), Ufo1GlimtGetter, XOR
          Ufo(Vaesen).GlimtTaeller = Ufo(Vaesen).GlimtTaeller - 1
        ELSE
          PUT (Ufo(Vaesen).x, Ufo(Vaesen).Y), Ufo1Getter, XOR
        END IF
      CASE 1
        PUT (Ufo(Vaesen).x, Ufo(Vaesen).Y), Ufo2Maske, AND
        IF Ufo(Vaesen).GlimtTaeller THEN
          PUT (Ufo(Vaesen).x, Ufo(Vaesen).Y), Ufo2GlimtGetter, XOR
          Ufo(Vaesen).GlimtTaeller = Ufo(Vaesen).GlimtTaeller - 1
        ELSE
          PUT (Ufo(Vaesen).x, Ufo(Vaesen).Y), Ufo2Getter, XOR
        END IF

      CASE 2
        PUT (Ufo(Vaesen).x, Ufo(Vaesen).Y), Ufo3Maske, AND
        IF Ufo(Vaesen).GlimtTaeller THEN
          PUT (Ufo(Vaesen).x, Ufo(Vaesen).Y), Ufo3GlimtGetter, XOR
          Ufo(Vaesen).GlimtTaeller = Ufo(Vaesen).GlimtTaeller - 1
        ELSE
          PUT (Ufo(Vaesen).x, Ufo(Vaesen).Y), Ufo3Getter, XOR
        END IF
      CASE 3
        PUT (Ufo(Vaesen).x, Ufo(Vaesen).Y), Ufo4Maske, AND
        IF Ufo(Vaesen).GlimtTaeller THEN
          PUT (Ufo(Vaesen).x, Ufo(Vaesen).Y), Ufo4GlimtGetter, XOR
          Ufo(Vaesen).GlimtTaeller = Ufo(Vaesen).GlimtTaeller - 1
        ELSE
          PUT (Ufo(Vaesen).x, Ufo(Vaesen).Y), Ufo4Getter, XOR
        END IF
      END SELECT
    END IF
  NEXT Vaesen

  CASE 3        'DropOpgradering
  FOR Taeller = 0 TO 2
    IF DropOpGradering(Taeller).Eksisterer = "T" THEN
      SELECT CASE DropOpGradering(Taeller).DropType
     
      CASE 0    'Laser
        PUT (DropOpGradering(Taeller).x, DropOpGradering(Taeller).Y), UpgradeMaske, AND
        PUT (DropOpGradering(Taeller).x, DropOpGradering(Taeller).Y), LaserUpgradeGetter, XOR
     
      CASE 1    'Skjold
        PUT (DropOpGradering(Taeller).x, DropOpGradering(Taeller).Y), UpgradeMaske, AND
        PUT (DropOpGradering(Taeller).x, DropOpGradering(Taeller).Y), SkjoldUpgradeGetter, XOR
     
      CASE 2    'Energi
        PUT (DropOpGradering(Taeller).x, DropOpGradering(Taeller).Y), UpgradeMaske, AND
        PUT (DropOpGradering(Taeller).x, DropOpGradering(Taeller).Y), EnergiUpgradeGetter, XOR

      CASE 3     'alien i faldskrm
        PUT (DropOpGradering(Taeller).x, DropOpGradering(Taeller).Y), RumvaesenIFaldskaermMaske, AND
        PUT (DropOpGradering(Taeller).x, DropOpGradering(Taeller).Y), RumvaesenIFaldskaermGetter, XOR
      END SELECT
    END IF
  NEXT Taeller

END SELECT

END SUB

SUB TegnStjernerTilSkaerm


FOR Taeller = 0 TO AntalStjerner - 1
  Stjerne(Taeller).Y = (Stjerne(Taeller).Y + StjerneData(Stjerne(Taeller).lag).Fart) MOD 200
  PSET (Stjerne(Taeller).x, Stjerne(Taeller).Y), StjerneData(Stjerne(Taeller).lag).farve
NEXT Taeller


END SUB

SUB VaelgStyring

DIM Valg AS INTEGER
DIM StyreMetode(0 TO 2) AS STRING

StyreMetode(0) = "         Tastatur        "
StyreMetode(1) = "         Joystick        "
StyreMetode(2) = " Det sdvanlige joystick "

DIM Forklaring(0 TO 2) AS STRING
Forklaring(0) = "Hvis du vil styre med piltasterne og Q/W/MELLEMRUM"
Forklaring(1) = "Hvis du styrer med et andet Joystick end sidste gang du spillede"
Forklaring(2) = "Hvis du styrer med det sdvanlige joystick"



COLOR 15, 1
CLS
COLOR 14, 3: LOCATE 1, 1: PRINT "         Valg af styremetode                                                    "
COLOR 14, 1
LOCATE 20, 29: PRINT "Hvad vil du styre med?"
GOSUB SkrivValgTilSkaerm


DO
  Tast$ = UCASE$(INKEY$)
  IF Tast$ = CHR$(0) + "H" THEN
    Valg = Valg - 1  'Op
    IF Valg < 0 THEN Valg = 2
    GOSUB SkrivValgTilSkaerm
  ELSEIF Tast$ = CHR$(0) + "P" THEN
    Valg = (Valg + 1) MOD 3  'Ned
    GOSUB SkrivValgTilSkaerm
  END IF
LOOP WHILE Tast$ <> CHR$(13) AND Tast$ <> CHR$(32)

SELECT CASE Valg

  CASE 0
  StyringMedJoyStick = "F"

  CASE 1
  JoystickKalibrering "Kalibrr"
  StyringMedJoyStick = "T"

  CASE 2
  JoystickKalibrering "HentFil"
  StyringMedJoyStick = "T"
  
END SELECT

EXIT SUB

SkrivValgTilSkaerm:
COLOR 7, 1
FOR x = 0 TO 2
LOCATE 7 + x * 4, 40 - (LEN(StyreMetode(x))) / 2: PRINT StyreMetode(x)
NEXT x
COLOR 31, 2
LOCATE 7 + Valg * 4, 40 - (LEN(StyreMetode(Valg))) / 2: PRINT StyreMetode(Valg)

COLOR 15, 1
LOCATE 20, 5: PRINT SPACE$(70)
LOCATE 20, 40 - (LEN(Forklaring(Valg))) / 2: PRINT Forklaring(Valg)

RETURN

END SUB

SUB VisBSVFil (FilNavn$)
DIM farve AS STRING * 1

DEF SEG = &HA000        'Indstiller segmentet til skrmhukommelsen

SCREEN 13

FOR col = 0 TO 255      'Frst mrklgges alle farver
  OUT &H3C8, col
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
NEXT col

BLOAD FilNavn$, 0       'Putter filen i skrmhukommelsen

FilFornavn$ = MID$(FilNavn$, 1, LEN(FilNavn$) - 4)      'Finder filens fornavn
FilNavn$ = FilFornavn$ + ".PAL"

OPEN FilNavn$ FOR INPUT AS #1  'For at f fejlbesked hvis noget gr galt
CLOSE #1

OPEN FilNavn$ FOR BINARY AS #1
  FOR col = 0 TO 255
    OUT &H3C8, col
    FOR x = 0 TO 2
      GET #1, , farve
      OUT &H3C9, ASC(farve)
    NEXT x
  NEXT col
CLOSE #1
WHILE LEN(INKEY$): WEND
SLEEP
WHILE LEN(INKEY$): WEND

SCREEN 0: WIDTH 80


END SUB

SUB VisFil (FilNavn AS STRING)

TopMargin% = 4
Venstremargin% = 5
AntalLinier% = 23
FremhaevFarve% = 11
DIM Linie AS INTEGER, Streng AS STRING * 73

'Denne SUB viser AntalLinier% fra Startlinie% og frem fra en fil

OPEN FilNavn FOR INPUT AS #1
    DO                          'Frst lses der hen til den frste linie
      IF EOF(1) THEN EXIT DO    'der skal vises
      LINE INPUT #1, Streng$
      Linie = Linie + 1
    LOOP WHILE Linie < LinieStart%
    LinierForbi = Linie 'Til at huske hvor mange linier vi er nede i filen
    Linie = 0
    DO
      IF EOF(1) THEN
        LinieStart% = LinieStart% - 1
        CLOSE #1
        EXIT SUB
      END IF
      LINE INPUT #1, Streng$
      IF LEFT$(Streng$, 1) = "#" THEN
        COLOR FremhaevFarve%
        Streng = MID$(Streng$, 2, LEN(Streng$) - 1)
      ELSE
        COLOR 7
        Streng = Streng$
      END IF
      LOCATE Linie + TopMargin%, Venstremargin%
      IF LEN(RTRIM$(Streng$)) THEN
        PRINT Streng$
      ELSE
        PRINT SPACE$(73)
      END IF
      Linie = Linie + 1
    LOOP WHILE Linie <> AntalLinier%
CLOSE #1
END SUB

SUB Xpress (text AS STRING, x%, Y%, FontColor%, Size%, Skygge%)

'Hvis fontcolor% > 15 s skrives der med disse farver
DIM farve(8) AS INTEGER
farve(0) = 7
farve(1) = 7
farve(2) = 15
farve(3) = 7
farve(4) = 7
farve(5) = 7
farve(6) = 7
farve(7) = 7

IF Skygge% THEN
  FOR Letter = 1 TO LEN(text)
     a = ASC(MID$(text, Letter, 1)) - 33
     IF a >= 0 AND a <= 140 THEN
      FOR x = 0 TO 5
          FOR Y = 0 TO 7
            IF Size% = 1 THEN
              IF ASC(Alfabet(a * 6 + x)) AND 2 ^ Y THEN PSET (x% + (Letter - 1) * 6 + x + 1, Y% + Y + 1), 0
            ELSE
              IF ASC(Alfabet(a * 6 + x)) AND 2 ^ Y THEN LINE (x% + ((Letter - 1) * 6 + x + 1) * Size%, Y% + (Y + 1) * Size%)-STEP(Size% - 1, Size% - 1), 0, BF
            END IF
          NEXT Y
        NEXT x
    END IF
  NEXT Letter
END IF

FOR Letter = 1 TO LEN(text)
   a = ASC(MID$(text, Letter, 1)) - 33
   IF a >= 0 AND a <= 140 THEN
    FOR x = 0 TO 5
        FOR Y = 0 TO 7
          IF Size% = 1 THEN
            IF FontColor% > 15 THEN
              IF ASC(Alfabet(a * 6 + x)) AND 2 ^ Y THEN PSET (x% + (Letter - 1) * 6 + x, Y% + Y), farve(Y)
            ELSE
              IF ASC(Alfabet(a * 6 + x)) AND 2 ^ Y THEN PSET (x% + (Letter - 1) * 6 + x, Y% + Y), FontColor%
            END IF
          ELSE
            IF FontColor% > 15 THEN
              IF ASC(Alfabet(a * 6 + x)) AND 2 ^ Y THEN LINE (x% + ((Letter - 1) * 6 + x) * Size%, Y% + Y * Size%)-STEP(Size% - 1, Size% - 1), farve(Y), BF
            ELSE
              IF ASC(Alfabet(a * 6 + x)) AND 2 ^ Y THEN LINE (x% + ((Letter - 1) * 6 + x) * Size%, Y% + Y * Size%)-STEP(Size% - 1, Size% - 1), FontColor%, BF
            END IF
          END IF
        NEXT Y
      NEXT x
  END IF
NEXT Letter

END SUB

